	PROGRAM ACP_TEST
C
C	ACP_TEST tests the template pseudo-driver and ACP as follows:
C
C	(1) Assigns a channel to the pseudo-device XX
C
C	(2) Asks for an Attention AST if the ACP dismounts
C
C	(3) Issues a read request to the pseudo-device
C
C	(4) Issues a write request to the pseudo-device
C
C	(5) Dismounts the ACP if requested.  (This requires
C	    OPER privilege)
C
C	On a read the template ACP rings the bell on the operator's
C	console (but does not read anything).  On a write it writes
C	CHAR_BUFFER to the operator's console.
C
C
C	Chuck Bolz, Boeing Computer Services/G4545, Jan. 1982
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	EXTERNAL ACP_AST
	INTEGER*2 IOSB(4)		! I/O status block
	INTEGER*2 IO_CHANNEL		! word to receive channel #
	BYTE DATA_BUFFER(132)		! a data buffer
	CHARACTER*132 CHAR_BUFFER	! the same data buffer
	EQUIVALENCE (DATA_BUFFER,CHAR_BUFFER)
	CHARACTER*1 YES_OR_NO		! interrogate the user
C
	INTEGER SYS$QIOW
	PARAMETER IO$_READVBLK = '31'X	! Read virtual block function code
	PARAMETER IO$_WRITEVBLK= '30'X	! Write virtual block function code
	PARAMETER IO$_ACPDISM='438'X	! ACPCONTROL + DISMOUNT
	PARAMETER IO$_SETAST='123'X	! SETMODE + SETATTNAST
C
C	Put something in the data buffer.
C
	CHAR_BUFFER = ' ACP Template Test.'
C
C	Assign a channel to template pseudo-device.
C
	CALL SYS$ASSIGN('XX',IO_CHANNEL,,)
C
C	Ask for AST notification if ACP dismounts or fails.
C
	IOSTATUS = SYS$QIOW(,%VAL(IO_CHANNEL),%VAL(IO$_SETAST),IOSB,,,
	1		     ACP_AST,0,,,,)
	PRINT 10,IOSTATUS
10	FORMAT(' Attention AST status code = ',Z5)
C
C	Issue a read and print the status code.
C
	IOSTATUS = SYS$QIOW(,%VAL(IO_CHANNEL),%VAL(IO$_READVBLK),IOSB,,,
	1			 DATA_BUFFER,%VAL(80),,,,,)
	PRINT 20,IOSB(1)
20	FORMAT(' Read status = ',Z5)
C
C	Issue a write and print the status code.
C
	IOSTATUS = SYS$QIOW(,%VAL(IO_CHANNEL),%VAL(IO$_WRITEVBLK),IOSB,,,
	1			 DATA_BUFFER,%VAL(80),,,,)
	PRINT 30,IOSB(1)
30	FORMAT(' Write status = ',Z5)
C
C	Ask the user if he wants to dismount the ACP.
C
	TYPE *,'Shall I dismount the ACP?  Type Y or N.'
	READ 40,YES_OR_NO
	IF (YES_OR_NO.NE.'Y') GO TO 60
40	FORMAT(A)
C
C	Dismount the ACP.
C
	IOSTATUS = SYS$QIOW(,%VAL(IO_CHANNEL),%VAL(IO$_ACPDISM),IOSB,,,
	1		         ,,,,,)
	PRINT 50,IOSTATUS
50	FORMAT(' Dismount status = 'Z5)
C
60	STOP
	END
	SUBROUTINE ACP_AST
	PRINT *,' ACP Dismounted and AST Delivered.'
	RETURN
	END
