$       SET NOVERIFY
$ !--------------------------------------------------------------------!
$ !     PROCEDURE:     LBN                                             !
$ !--------------------------------------------------------------------!
$ !     PROGRAMMER:    KEVIN KLUGHART                                  !
$ !--------------------------------------------------------------------!
$ !     DATE:          05-04-82 @ 06:00 CDST                           !
$ !--------------------------------------------------------------------!
$ !     PURPOSE:       This procedure enables the system manager to    !
$ !                    convert from cylinder, track, and sector on     !
$ !                    RM05 disks to/from logical block number (LBN).  !
$ !                    This is useful in converting cylinder, track,   !
$ !                    and sector information obtained from the EVRAC  !
$ !                    diagnostic (READALL section) to perform manual  !
$ !                    bad block entries with the BAD utility (/UPD)   !
$ !--------------------------------------------------------------------!
$ !     FROM UTILITIES PROCEDURE MANUAL, PAGE 4-16                     !
$ !                                                                    !
$ !     LBN = (((cylinder number * tracks-per-cylinder)+ track number) !
$ !           * sectors-per-track) + sector number                     !
$ !--------------------------------------------------------------------!
$ !     Display information on operation of logical block utility      !
$ !--------------------------------------------------------------------!
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "                ***  Logical Block Number Utility  ***"
$       WRITE SYS$OUTPUT " "
$ !--------------------------------------------------------------------!
$ !     Determine Tracks/Cylinder and Sectors/Track parameters         !
$ !--------------------------------------------------------------------!
$       WRITE SYS$OUTPUT "           ***  RM05 uses following default parameters  ***"
$       WRITE SYS$OUTPUT " "
$       INQUIRE TPC "Tracks/Cylinder (19)"
$       IF (TPC .EQS. "") THEN TPC:="19"
$       TPC = 'TPC'
$
$       INQUIRE SPT "Sectors/Track (32)"
$       IF (SPT .EQS. "") THEN SPT:="32"
$       SPT = 'SPT'
$ !--------------------------------------------------------------------!
$ !     Enter logical block number (otherwise cylinder,track,sector)   !
$ !--------------------------------------------------------------------!
$ TEST: WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "Enter LBN or <CR> for cylinder, track, and sector"
$
$       INQUIRE LBN "Enter Logical Block (0)"
$       IF (LBN .EQS. "") THEN LBN:="0"
$       LBN = 'LBN'
$ !--------------------------------------------------------------------!
$ !     Compute Cylinder, Track, and Sector                            !
$ !--------------------------------------------------------------------!
$       IF (LBN .EQ. 0) THEN GOTO CR
$       SEC = (LBN-((LBN/SPT)*SPT))
$       TRK = ((LBN/SPT)-(((LBN/SPT)/TPC)*TPC))
$       CYL = ((LBN/SPT)/TPC)
$ !--------------------------------------------------------------------!
$ !     Display Cylinder, Track, and Sector                            !
$ !--------------------------------------------------------------------!
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "Equivalent Cylinder = ''CYL'"
$       WRITE SYS$OUTPUT "Equivalent Track    = ''TRK'"
$       WRITE SYS$OUTPUT "Equivalent Sector   = ''SEC'"
$       GOTO TEST
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Enter Cylinder, Track, and Sector                              !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ CR:   WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT " "
$       INQUIRE CYL "Enter Cylinder (0)"
$       IF (CYL .EQS. "") THEN CYL:="0"
$       CYL = 'CYL'
$
$       INQUIRE TRK "Enter Track (0)"
$       IF (TRK .EQS. "") THEN TRK:="0"
$       TRK = 'TRK'
$
$       INQUIRE SEC "Enter Sector (0)"
$       IF (SEC .EQS. "") THEN SEC:="0"
$       SEC = 'SEC'
$ !--------------------------------------------------------------------!
$ !     Display Logical Block Number                                   !
$ !--------------------------------------------------------------------!
$       LBN = (((CYL*TPC)+TRK)*SPT)+SEC
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "Equivalent logical block number (LBN) = ''LBN'"
$       GOTO TEST
$ !--------------------------------------------------------------------!
$ !     END OF MAIN PROCEDURE LBN                                      !
$ !--------------------------------------------------------------------!
