      PROGRAM TELL
C----------------------------------------------------------------------*
C     PROGRAM:      TELL                                               *
C----------------------------------------------------------------------*
C     LANGUAGE:     VAX-11 FORTRAN V2.0-2                              *
C     SYSTEM:       VAX-11/780                                         *
C                   VAX/VMS V2.3                                       *
C                   MOSTEK CORPORATION                                 *
C                   COMPUTER AIDS TO DESIGN DEPARTMENT                 *
C                   1215 WEST CROSBY ROAD                              *
C                   CARROLLTON, TEXAS  75006                           *
C                   (214)  323-8813                                    *
C----------------------------------------------------------------------*
C     PROGRAMMER:   KEVIN KLUGHART                                     *
C----------------------------------------------------------------------*
C     DATE:         09-22-81 @ 07:00 CDST                              *
C----------------------------------------------------------------------*
C     PURPOSE:      THIS PROGRAM ENABLES A NON-PRIVILEGED USER TO      *
C                   BROADCAST MESSAGES TO TERMINALS WHICH HE HAS       *
C                   ALLOCATED, WITHOUT GIVING THE USER THE VMS         *
C                   OPERATOR PRIVILEGE.  THE UIC OF THE TERMINAL TO    *
C                   WHICH THE REQUEST IS DIRECTED *MUST* MATCH THAT    *
C                   OF THE CURRENT PROCESS OR A PRIVILEGE VIOLATION    *
C                   IS FLAGGED.  THE GENERAL FORMAT FOR THE COMMAND IS:*
C                                                                      *
C                        $TELL  terminal  [message-text]               *
C----------------------------------------------------------------------*
C     EXTERNALS:    STRING LIBRARY                                     *
C                   SYS$JPI PROCESS INFORMATION SUBROUTINE             *
C----------------------------------------------------------------------*

C----------------------------------------------------------------------*
C                                                                      *
C     PROGRAM PARAMETERS                                               *
C                                                                      *
C----------------------------------------------------------------------*
C     NUMERIC PARAMETERS                                               *
C----------------------------------------------------------------------*
C     USEFUL CONSTANTS                                                 *
C----------------------------------------------------------------------*
      PARAMETER FOUR             = 4              ! USEFUL CONSTANT
      PARAMETER FULL             = 15             ! FULL ERROR MESSAGES
      PARAMETER MAX              = 511            ! MAXIMUM STRING LENGTH
      PARAMETER NAM              = 15             ! MAXIMUM # CHARS IN NAME
      PARAMETER ONE              = 1              ! USEFUL CONSTANT
      PARAMETER WILDCARD         = -ONE           ! WILDCARD PROCESS SEARCH
      PARAMETER ZERO             = 0              ! USEFUL CONSTANT
C----------------------------------------------------------------------*
C     EXTERNALS                                                        *
C----------------------------------------------------------------------*
      EXTERNAL JPI$_PID
      EXTERNAL JPI$_TERMINAL
      EXTERNAL JPI$_UIC
      EXTERNAL SS$_NOMOREPROC
      EXTERNAL SS$_NOPRIV
      EXTERNAL SS$_NORMAL
      EXTERNAL SS$_NOSUCHDEV
C----------------------------------------------------------------------*
C     CHARACTER                                                        *
C----------------------------------------------------------------------*
      CHARACTER*(MAX) MESSAGE
      CHARACTER*(NAM) PRCTRM
      CHARACTER*(NAM) TERMINAL
C----------------------------------------------------------------------*
C     INTEGER*4                                                        *
C----------------------------------------------------------------------*
      INTEGER*4 FIRST
      INTEGER*4 JPI$_PID
      INTEGER*4 JPI$_TERMINAL
      INTEGER*4 JPI$_UIC
      INTEGER*4 LENGTH
      INTEGER*4 LIB$GET_FOREIGN
      INTEGER*4 LIB$PUT_OUTPUT
      INTEGER*4 LIM
      INTEGER*4 MSGLEN
      INTEGER*4 PID
      INTEGER*4 PID_SEARCH
      INTEGER*4 POINTER
      INTEGER*4 PRCUIC
      INTEGER*4 SS$_NOMOREPROC
      INTEGER*4 SS$_NOPRIV
      INTEGER*4 SS$_NORMAL
      INTEGER*4 SS$_NOSUCHDEV
      INTEGER*4 STATUS
      INTEGER*4 SYS$BRDCST
      INTEGER*4 SYS$GETMSG
      INTEGER*4 SYS$JPI
      INTEGER*4 TRMLEN
      INTEGER*4 UIC

C----------------------------------------------------------------------*
C     SECTION 100                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     INITIALIZATION                                                   *
C                                                                      *
C----------------------------------------------------------------------*
C     GET THE USER COMMAND LINE                                        *
C     PARSE OUT TERMINAL NAME AND MESSAGE TEXT                         *
C     DETERMINE UIC OF CURRENT PROCESS (MUST MATCH TERMINAL UIC!!)     *
C----------------------------------------------------------------------*
  100 CONTINUE
      STATUS=LIB$GET_FOREIGN(MESSAGE,'Enter Terminal Name: ',LIM)
      IF (STATUS .NE. %LOC(SS$_NORMAL)) GO TO 800
      IF (LIM .EQ. ZERO) GO TO 100

      CALL GET_WORD(MESSAGE,TERMINAL)
      CALL DELETE_CONTROL(TERMINAL)
      CALL DELETE_BLANKS(TERMINAL)
      TRMLEN=LENGTH(TERMINAL)
      STATUS=%LOC(SS$_NOSUCHDEV)
      IF (TRMLEN .LT. FOUR) GO TO 800

  110 POINTER=FIRST(MESSAGE)
      IF (POINTER .EQ. ZERO)
     1     STATUS=LIB$GET_FOREIGN(MESSAGE,'Enter Message: ',MSGLEN)
      IF (POINTER .NE. ZERO) MESSAGE=MESSAGE(POINTER:)
      MSGLEN=LENGTH(MESSAGE)
      IF (MSGLEN .EQ. ZERO) GO TO 110
C----------------------------------------------------------------------*
C     CALCULATE UIC OF CURRENT PROCESS                                 *
C----------------------------------------------------------------------*
      CALL SYS$JPI(,,%LOC(JPI$_UIC),UIC,)

C----------------------------------------------------------------------*
C     SECTION 200                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     SEARCH THROUGH SYSTEM PROCESS TABLE FOR TERMINAL NAME MATCH      *
C                                                                      *
C----------------------------------------------------------------------*
  200 CONTINUE
      PID_SEARCH=WILDCARD

  210 CONTINUE
      STATUS=SYS$JPI(PID_SEARCH,,%LOC(JPI$_PID),PID,)
      IF (STATUS .EQ. %LOC(SS$_NOMOREPROC)) GO TO 300
      IF (STATUS .NE. %LOC(SS$_NORMAL)) GO TO 800
      STATUS=SYS$JPI(PID,,%LOC(JPI$_TERMINAL),PRCTRM,)
      CALL DELETE_CONTROL(PRCTRM)
      LIMIT=LENGTH(PRCTRM)
      IF (INDEX(PRCTRM,TERMINAL) .EQ. ZERO) GO TO 210
C----------------------------------------------------------------------*
C     A TERMINAL NAME MATCH HAS OCCURRED - CHECK FOR VALID UIC         *
C----------------------------------------------------------------------*
      STATUS=SYS$JPI(PID,,%LOC(JPI$_UIC),PRCUIC,)
      IF (STATUS .NE. %LOC(SS$_NORMAL)) GO TO 800
      
      STATUS=%LOC(SS$_NOPRIV)
      IF (UIC .NE. PRCUIC) GO TO 800
C----------------------------------------------------------------------*
C     SECTION 300                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     UIC IS VALID OR TERMINAL IS AVAILABLE - DISPLAY USER MESSAGE     *
C                                                                      *
C----------------------------------------------------------------------*
  300 CONTINUE
      STATUS=SYS$BRDCST(MESSAGE(ONE:MSGLEN),TERMINAL(ONE:TRMLEN))
      IF (STATUS .EQ. %LOC(SS$_NORMAL)) GO TO 900

C----------------------------------------------------------------------*
C     SECTION 800                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     VAX/VMS SYSTEM SERVICE ERROR REPORTING                           *
C                                                                      *
C----------------------------------------------------------------------*
  800 CONTINUE
      CALL SYS$GETMSG(%VAL(STATUS),LIM,MESSAGE,%VAL(FULL),)
      STATUS=LIB$PUT_OUTPUT(MESSAGE(ONE:LIM))
C----------------------------------------------------------------------*
C     SECTION 900                                                      *
C----------------------------------------------------------------------*
C                                                                      *
C     PROGRAM TERMINATION                                              *
C                                                                      *
C----------------------------------------------------------------------*
  900 CONTINUE
C----------------------------------------------------------------------*
C     END OF MAIN PROGRAM TELL                                         *
C----------------------------------------------------------------------*
      END
